/*
   mp_simple_out.c

   (C) 2002 G Savchuk, Fidelis Security Systems, Inc

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

 */

/*$Id: libmp_simple_out.c,v 1.2 2004/12/11 21:15:55 jleplast Exp $*/

#include <stdio.h>
#include "mp_export.h"

# define A_id uar->event.event_id
# define L_id ulr->log.event.event_id

/* declarations
 */
mp_out_init_t mp_out_init;
mp_out_alert_t mp_out_alert;
mp_out_log_t mp_out_log;
mp_out_fini_t mp_out_fini;

static serv_t *OS;

/* implementations */
/* this function gets executed by dlopen automatically */
void _init()
{
  printf(
	 "-------------------------------------------\n"
	 "mp_simple_out - mudpit output module example.\n"
	 "(c) 2002 G Savchuk, Fidelis Security Systems.\n"
	 "-------------------------------------------\n"
	 );
  fflush(stdout);
}

int mp_out_init(char *args, serv_t *os)
{
  OS = os;
  OS->logprint("out_init(%s)\n", args ? args : "<null>");
  return 1;
}

int mp_out_alert(void *ptr)
{
  UnifiedAlertRecord *uar = (UnifiedAlertRecord *)ptr;

  OS->logprint("A: %d\t%d.%d\n", A_id, uar->ts.tv_sec, uar->ts.tv_usec);
  return 1;
}

int mp_out_log(void *ptr)
{
  UnifiedLogRecord *ulr = (UnifiedLogRecord *)ptr;

  OS->logprint("L: %d\t%d.%d\n", L_id, ulr->log.pkth.ts.tv_sec, ulr->log.pkth.ts.tv_usec);
  return 1;
}

void mp_out_fini()
{
  OS->logprint("Finished\n");
}

#undef A_id
#undef U_id
