/*
   mp_conf.h

   Copyright(C) 2002 Gene Savchuk, Fidelis Security Systems

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* $Id: mp_conf.h,v 1.1.1.1 2004/12/08 02:44:16 jleplast Exp $ */

#ifndef _MP_CONF_H_
#define _MP_CONF_H_

/* this structure contains mudpit's global conf. parameters */
typedef struct
{
  char *config_dir; /* this is a dirname part of config_file variable.
		       it is used to resolve relative filenames */
  char *config_file;
  char *class_file;
  char *sid_file;
  char *gen_file;
  char *urlhead_file;
  char *pid_file;
  int daemon_flag;
  int verbose;
  int run_once;
  int nice;
} global_conf_t;

extern global_conf_t GCF;

void parse_args(int argc, char **argv);
void parse_conf();
void print_conf(int argc, char **argv);

#endif
