/*
   mp_lexer.l

   Copyright(C) 2002 Gene Savchuk, Fidelis Security Systems

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* $Id: mp_lexer.l,v 1.2 2004/12/11 21:40:14 jleplast Exp $ */

%option yylineno
%option noyywrap
%option nostdinit

%x comment
%x string

%{
/* for some reasons, this important definition
   wouldn't go to automatically-generated parser.h */
#define YYSTYPE char *
extern YYSTYPE yylval;

#include "mp_parser.h"
%}

DIGIT [0-9]+

%%

^#[^\n]*         BEGIN(comment);
<comment>\n      { BEGIN(INITIAL); }

\"               BEGIN(string);
<string>\n       return ERROR;
<string>[^\"]*   { yylval= (char *) yytext; return STRING; }
<string>\"       { *yytext= 0; BEGIN (INITIAL); }

"="|"{"|"}"|","  return *yytext;

global         return T_GLOBAL;

daemon         return T_DAEMON;
verbose        return T_VERBOSE;
class_file     return T_CLASS_FILE;
sid_file       return T_SID_FILE;
gen_file       return T_GEN_FILE;
ref_file       return T_URL_FILE;
pid_file       return T_PID_FILE;
nice           return T_NICE;
run_once       return T_RUN_ONCE;

spool            return T_SPOOL;
arch_dir         return T_ARCH_DIR;
checkpoint       return T_CHECK;
output           return T_OMOD;
user             return T_USER;
delete_processed return T_DEL_PROC;
lock             return T_LOCK;

{DIGIT}        {yylval = (char *) yytext; return NUM;}

%%

