/*
   mp_output.c

   Copyright(C) 2002 Gene Savchuk, Fidelis Security Systems

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* $Id: mp_output.c,v 1.2 2004/12/11 21:15:55 jleplast Exp $ */

#include "config.h"

#include "mp_maps.h"
#include "mp_output.h"
#include "mp_util.h"

static serv_t services = {
  (serv_log_t *)   logprint,
  (serv_fatal_t *) child_fatal, /* less dangerous then fatal() */
  (serv_debug_t *) debug,

  (serv_sid_t *)   get_sid,
  (serv_class_t *) get_class,
  (serv_url_t *)   get_url,
  (serv_proto_name_t *) proto_name,
};

serv_t *init_services(void) {
  return &services;
}

