#include <stdlib.h>
#ifndef lint
#ifdef __unused
__unused
#endif
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.37 2003/02/12 18:03:55 davidc Exp $";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
#if defined(__cplusplus) || __STDC__
static int yygrowstack(void);
#else
static int yygrowstack();
#endif
#define YYPREFIX "yy"
#line 25 "mp_parser.y"
#define YYSTYPE char *

#define YYDEBUG 3
#define YYERROR_VERBOSE

#include "config.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include <pwd.h>
#include <sys/types.h>
#include <errno.h>

#include "mp_conf.h"
#include "mp_spoolman.h"
#include "mp_util.h"

extern int yylineno;
extern int yylex(void);

static void yyerror(char *msg)
{
/*   printf("line %d: %s\n", yylineno, msg); */
}

#define ASSIGN(x,y) if(x) free(x); x = strdup(y)
static void add_spool(char *dirname);
static void add_module(char *name, char *params);
static void get_uid(char *name);
static char *an(char *);

/*
  variables to save the spool configuration data.
  They are used in add_spool()
  The reason to do it this way is that add_spool is called after
  bison reads closing '}' in the 'spool' statement.
 */
static char *_yy_check_file;
static char *_yy_arch_dir;
static char *_yy_lock;

static char *_yy_class_file;
static char *_yy_sid_file;
static char *_yy_gen_file;
static char *_yy_urlhead_file;

static int   _yy_delete_processed;
static uid_t _yy_uid;
static gid_t _yy_gid;

static out_mod_t *_yy_o_mods;
static out_mod_t **_yy_mod_cur = &_yy_o_mods;
#line 79 "mp_parser.c"
#define YYERRCODE 256
#define ERROR 257
#define STRING 258
#define NUM 259
#define ID 260
#define T_GLOBAL 261
#define T_DAEMON 262
#define T_CF_FILE 263
#define T_CLASS_FILE 264
#define T_SID_FILE 265
#define T_GEN_FILE 266
#define T_URL_FILE 267
#define T_PID_FILE 268
#define T_VERBOSE 269
#define T_NICE 270
#define T_RUN_ONCE 271
#define T_SPOOL 272
#define T_ARCH_DIR 273
#define T_CHECK 274
#define T_DEL_PROC 275
#define T_OMOD 276
#define T_USER 277
#define T_LOCK 278
const short yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    2,    2,    3,    3,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,
};
const short yylen[] = {                                         2,
    0,    2,    4,    2,    5,    2,    1,    0,    2,    1,
    3,    3,    3,    3,    3,    3,    1,    3,    3,    3,
    3,    5,    3,    3,    1,    3,    3,    3,    3,
};
const short yydefred[] = {                                      1,
    0,    0,    0,    2,    0,    0,   10,    0,    0,    0,
    0,    0,    0,    0,   17,    0,    7,    8,    0,    0,
    0,    0,    0,    0,    0,    3,    6,    0,   12,   13,
   14,   15,   16,   11,   18,    0,    0,    0,    0,    0,
    0,   25,    0,    0,    0,    5,    9,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   26,   27,   28,   29,
   20,   19,    0,   23,   24,    0,   22,
};
const short yydgoto[] = {                                       1,
    4,   16,   28,   17,   47,
};
const short yysindex[] = {                                      0,
 -259, -120, -254,    0, -248, -118,    0,  -55,  -54,  -53,
  -52,  -51,  -50,  -49,    0,  -93,    0,    0, -234, -233,
 -232, -231, -230, -229, -228,    0,    0, -125,    0,    0,
    0,    0,    0,    0,    0,  -32,  -28,  -27,  -26,  -25,
  -24,    0,  -23,  -22,  -21,    0,    0, -217, -216, -215,
 -214, -213, -212, -211, -210, -209,    0,    0,    0,    0,
    0,    0,    6,    0,    0, -207,    0,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    1,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -110,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
    0,    0,    0,   36,    0,
};
#define YYTABLESIZE 273
const short yytable[] = {                                      46,
    4,    2,    5,    6,   18,   19,   20,   21,   22,   23,
   24,   25,    3,    7,   21,    8,    9,   10,   11,   12,
   13,   14,   15,   29,   30,   31,   32,   33,   48,   34,
   35,   26,   49,   50,   51,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
   67,   27,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   36,   37,
   38,   39,    0,    0,    0,    0,    0,   40,   41,   42,
   43,   44,   45,   21,   21,   21,   21,    0,    0,    0,
    0,    0,   21,   21,   21,   21,   21,   21,    7,    0,
    8,    9,   10,   11,   12,   13,   14,   15,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    4,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    4,
};
const short yycheck[] = {                                     125,
    0,  261,  123,  258,  123,   61,   61,   61,   61,   61,
   61,   61,  272,  262,  125,  264,  265,  266,  267,  268,
  269,  270,  271,  258,  258,  258,  258,  258,   61,  259,
  259,  125,   61,   61,   61,   61,   61,   61,   61,   61,
  258,  258,  258,  258,  258,  258,  258,  258,  258,   44,
  258,   16,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  264,  265,
  266,  267,   -1,   -1,   -1,   -1,   -1,  273,  274,  275,
  276,  277,  278,  264,  265,  266,  267,   -1,   -1,   -1,
   -1,   -1,  273,  274,  275,  276,  277,  278,  262,   -1,
  264,  265,  266,  267,  268,  269,  270,  271,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  261,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  272,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 278
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'='",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ERROR","STRING",
"NUM","ID","T_GLOBAL","T_DAEMON","T_CF_FILE","T_CLASS_FILE","T_SID_FILE",
"T_GEN_FILE","T_URL_FILE","T_PID_FILE","T_VERBOSE","T_NICE","T_RUN_ONCE",
"T_SPOOL","T_ARCH_DIR","T_CHECK","T_DEL_PROC","T_OMOD","T_USER","T_LOCK",
};
const char * const yyrule[] = {
"$accept : input",
"input :",
"input : input line",
"line : T_GLOBAL '{' global '}'",
"line : T_SPOOL STRING",
"line : T_SPOOL STRING '{' spool '}'",
"global : global _global",
"global : _global",
"spool :",
"spool : spool _spool",
"_global : T_DAEMON",
"_global : T_VERBOSE '=' NUM",
"_global : T_CLASS_FILE '=' STRING",
"_global : T_SID_FILE '=' STRING",
"_global : T_GEN_FILE '=' STRING",
"_global : T_URL_FILE '=' STRING",
"_global : T_PID_FILE '=' STRING",
"_global : T_RUN_ONCE",
"_global : T_NICE '=' NUM",
"_spool : T_CHECK '=' STRING",
"_spool : T_ARCH_DIR '=' STRING",
"_spool : T_OMOD '=' STRING",
"_spool : T_OMOD '=' STRING ',' STRING",
"_spool : T_USER '=' STRING",
"_spool : T_LOCK '=' STRING",
"_spool : T_DEL_PROC",
"_spool : T_CLASS_FILE '=' STRING",
"_spool : T_SID_FILE '=' STRING",
"_spool : T_GEN_FILE '=' STRING",
"_spool : T_URL_FILE '=' STRING",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 151 "mp_parser.y"

static void add_spool(char *dirname)
{
  int i = SPOOLS_NUMBER;

  assert(dirname);

  SPOOLS = array_alloc(SPOOLS, SPOOLS_NUMBER++, sizeof(spool_t), 2);

  memset(&SPOOLS[i], 0, sizeof(spool_t));

  SPOOLS[i].spool_dir = strdup(dirname);

  /* those two have been already strdup'ed by ASSIGN() */
  SPOOLS[i].check_file = _yy_check_file;
  SPOOLS[i].arch_dir =   _yy_arch_dir;
  SPOOLS[i].lock =       _yy_lock;

  SPOOLS[i].o_mods = _yy_o_mods;

  SPOOLS[i].delete_processed = _yy_delete_processed;
  SPOOLS[i].uid = _yy_uid;
  SPOOLS[i].gid = _yy_gid;

  SPOOLS[i].class_file =   _yy_class_file;
  SPOOLS[i].sid_file =     _yy_sid_file;
  SPOOLS[i].gen_file =     _yy_gen_file;
  SPOOLS[i].urlhead_file = _yy_urlhead_file;

  /* now reset variables to process the new "spool" statement */
  _yy_class_file = NULL;
  _yy_sid_file = NULL;
  _yy_gen_file = NULL;
  _yy_urlhead_file = NULL;
  _yy_check_file = NULL;
  _yy_arch_dir = NULL;
  _yy_o_mods = NULL;
  _yy_lock = NULL;
  _yy_delete_processed = 0;
  _yy_uid = 0;
  _yy_gid = 0;

  _yy_mod_cur = &_yy_o_mods;
}

static void add_module(char *name, char *params)
{
  assert(name);
  *_yy_mod_cur = my_alloc(sizeof(out_mod_t));

  debug(V_func, "adding module '%s'\n", (*_yy_mod_cur)->name = strdup(name));
  if(params)
    debug(V_func, "adding parameters '%s'\n", (*_yy_mod_cur)->params = strdup(params));

  _yy_mod_cur = &(*_yy_mod_cur)->next;
}

static void get_uid(char *name)
{
  assert(name);

  if(getuid()) {
    logprint("%s:%d: \"user %s\" statement won't work.\n",
	GCF.config_file, yylineno, name);
  }

  else {
    struct passwd *pw = getpwnam(name);

    if(!pw) fatal("%s:%d: '%s': no such user\n",
		  GCF.config_file, yylineno, name);

    _yy_uid = pw->pw_uid;
    _yy_gid = pw->pw_gid;	/* primary group */
  }
}

static char *an(char *name)
{
  char *c = name;
  if(!name) return NULL;
  for( ; *c ; c++)
    if(isalnum(*c) || *c == '_');
    else fatal("%s:%d: \"%s\" contains an illegal symbol '%c'\n",
	       GCF.config_file, yylineno, name, *c);

  return name;
}
#line 377 "mp_parser.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 4:
#line 114 "mp_parser.y"
{ add_spool(yyvsp[0]); }
break;
case 5:
#line 115 "mp_parser.y"
{ add_spool(yyvsp[-3]); }
break;
case 10:
#line 127 "mp_parser.y"
{ GCF.daemon_flag = 1; }
break;
case 11:
#line 128 "mp_parser.y"
{ GCF.verbose += atoi(yyvsp[0]); }
break;
case 12:
#line 129 "mp_parser.y"
{ ASSIGN(GCF.class_file,   yyvsp[0]); }
break;
case 13:
#line 130 "mp_parser.y"
{ ASSIGN(GCF.sid_file,     yyvsp[0]); }
break;
case 14:
#line 131 "mp_parser.y"
{ ASSIGN(GCF.gen_file,     yyvsp[0]); }
break;
case 15:
#line 132 "mp_parser.y"
{ ASSIGN(GCF.urlhead_file, yyvsp[0]); }
break;
case 16:
#line 133 "mp_parser.y"
{ ASSIGN(GCF.pid_file,     yyvsp[0]); }
break;
case 17:
#line 134 "mp_parser.y"
{ GCF.run_once = 1; }
break;
case 18:
#line 135 "mp_parser.y"
{ GCF.nice = atoi(yyvsp[0]); }
break;
case 19:
#line 138 "mp_parser.y"
{ ASSIGN(_yy_check_file, yyvsp[0]); }
break;
case 20:
#line 139 "mp_parser.y"
{ ASSIGN(_yy_arch_dir, yyvsp[0]); }
break;
case 21:
#line 140 "mp_parser.y"
{ add_module(yyvsp[0], NULL); }
break;
case 22:
#line 141 "mp_parser.y"
{ add_module(yyvsp[-2], yyvsp[0]); }
break;
case 23:
#line 142 "mp_parser.y"
{ get_uid(yyvsp[0]); }
break;
case 24:
#line 143 "mp_parser.y"
{ ASSIGN(_yy_lock, an(yyvsp[0])); }
break;
case 25:
#line 144 "mp_parser.y"
{ _yy_delete_processed = 1; }
break;
case 26:
#line 145 "mp_parser.y"
{ ASSIGN(_yy_class_file,   yyvsp[0]); }
break;
case 27:
#line 146 "mp_parser.y"
{ ASSIGN(_yy_sid_file,     yyvsp[0]); }
break;
case 28:
#line 147 "mp_parser.y"
{ ASSIGN(_yy_gen_file,     yyvsp[0]); }
break;
case 29:
#line 148 "mp_parser.y"
{ ASSIGN(_yy_urlhead_file, yyvsp[0]); }
break;
#line 660 "mp_parser.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
